<?php
/*

-= ERROR! =-

If you can read this you do not have PHP installed or configured properly on your server.
PHP is one of the minimum requirements of all Interspire products.

Please have your host install or configure PHP for you before contacting Interspire.

*/


/**
 * 
 * This file checks for Interpire Email Marketer-specific requirements.
 *
 */

session_start();
if (!isset($_GET['a'])) {
    $_SESSION['CHECK_SESSION_CHECK'] = true;
    $_SESSION['time'] = time();
    header('Location: ' . $_SERVER['PHP_SELF'] . '?a=sessionCheck');
}

if (isset($_SESSION['CHECK_SESSION_CHECK'])) {
    define('CHECK_SESSION_OK', true);
    define('CHECK_SESSION_TIME', $_SESSION['time']);
} else {
    if (empty($_SESSION)) {
        define('CHECK_SESSION_OK', false);
    }
}

error_reporting(0);
ini_set('display_errors', 0);

// PHP checks
define('CHECK_CURL_AVAILABLE', extension_loaded('curl'));
define('CHECK_URL_FOPEN', ini_get('allow_url_fopen'));

define('CHECK_FTP_AVAILABLE', extension_loaded('ftp'));
define('CHECK_FILE_UPLOADS', (bool)ini_get('file_uploads'));
// define('CHECK_PGSQL_AVAILABLE', extension_loaded('pgsql'));
define('CHECK_IMAP_AVAILABLE', extension_loaded('imap'));
define('CHECK_GD_AVAILABLE', extension_loaded('gd'));
define('CHECK_ZLIB_AVAILABLE', extension_loaded('zlib'));
define('CHECK_PSPELL_AVAILABLE', extension_loaded('pspell'));
define('CHECK_FSOCKOPEN_AVAILABLE', function_exists('fsockopen'));
define('CHECK_SIMPLEXML_AVAILABLE', extension_loaded('simplexml'));
define('CHECK_SOAP_AVAILABLE', extension_loaded('soap'));

define('CHECK_SESSION_AUTOSTART', (bool)ini_get('session.auto_start'));
define('CHECK_SESSION_DIR_EXISTS', (bool)is_dir(session_save_path()));
define('CHECK_SESSION_REFERER_CHECK_CORRECT', ini_get('session.referer_check') == '' || str_contains($_SERVER['HTTP_HOST'] ?? '', ini_get('session.referer_check')));

// Modern extension checks
define('CHECK_DOM_AVAILABLE', extension_loaded('dom'));
define('CHECK_MBSTRING_AVAILABLE', extension_loaded('mbstring'));
define('CHECK_JSON_AVAILABLE', extension_loaded('json'));

define('CHECK_PHP_SAPI', php_sapi_name());

define('CHECK_PASS', '<div class="CheckResult Pass">OK!</div>');
define('CHECK_FAIL', '<div class="CheckResult Fail">Not OK</div>');
define('CHECK_UNKNOWN', '<div class="CheckResult Unknown">Unknown</div>');

define('CHECK_BASEDIR_OK', empty(ini_get('open_basedir')));

// Apache module checks
if (in_array(CHECK_PHP_SAPI, ['apache', 'apache2handler'])) {
    define('CHECK_MOD_REWRITE_AVAILABLE', in_array('mod_rewrite', parseApacheModules()));
    define('CHECK_MOD_SECURITY_ENABLED', in_array('mod_security', parseApacheModules()));
} else {
    define('CHECK_MOD_REWRITE_AVAILABLE', null);
    define('CHECK_MOD_SECURITY_ENABLED', null);
}

define('CHECK_CGI_MODE', str_contains(CHECK_PHP_SAPI, 'cgi'));

// Check MySQLi version
$mysqli_version = null;
if (extension_loaded('mysqli')) {
    $mysqli = new mysqli();
    $mysqli_version = $mysqli->client_info;
    $mysqli->close();
}
define('CHECK_MYSQLi_AVAILABLE', extension_loaded('mysqli'));
define('MYSQLi_VERSION_CHECK', $mysqli_version);

// Remote URL access check
$ok = false;

if (CHECK_CURL_AVAILABLE) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://www.interspire.com/');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);

    $temp = curl_exec($ch);
    curl_close($ch);

    if (!empty($temp)) {
        $ok = true;
    }
}

if (!$ok && CHECK_URL_FOPEN) {
    $context = stream_context_create([
        'ssl' => [
            'verify_peer' => true,
            'verify_peer_name' => true,
        ]
    ]);
    $temp = @file_get_contents('https://www.interspire.com/', false, $context);
    if (!empty($temp)) {
        $ok = true;
    }
}

define('ACCESS_REMOTE_URL', $ok);

?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Interspire System Compatibility Check Script</title>
    <meta name="robots" content="noindex, nofollow">
    <link rel="icon" href="https://www.interspire.com/favicon.ico">
    <style>
        /* CSS styles remain the same */
        
		html {
			color: #32393D;
			font-family: Arial, Tahoma, Helvetica, sans-serif;
		}

		.Header {
			height: 70px;
		}

		h1 {
			background: white url(https://www.interspire.com/assets/logo_small.png) center left no-repeat;
			color: #FE4819;
			font-size: 1.7em;
			font-weight: normal;
			height: 60px;
			padding-left: 180px;
			padding-top: 30px;
			margin: 0;
		}

		h2 {
			color: #196297;
		}

		.CheckResult {
			color: white;
		}

		.Pass {
			background-color: green;
		}

		.Fail {
			background-color: red;
		}

		.Unknown {
			background-color: blue;
		}

		.Clear {
			clear: both;
		}

		dt {
			width: 300px;
			float: left;
			border-top: 1px solid #CACACA;
			padding: 3px;
		}

		dd.CheckResult {
			float: left;
			padding: 3px;
			margin-bottom: 1px;
			border-top: 1px solid #CACACA;
			margin-left: 0;
		}

		dd.CheckResultFeature,
		dd.CheckResultFix {
			clear: left;
			margin: 0;
			padding-left: 20px;
			font-size: 0.9em;
		}

		fieldset {
			width: 600px;
			border-color: #EEEEEE;
			padding: 1em;
		}

		legend {
			font-weight: bold;
		}

		em {
			color: #FE4819;
		}

		a {
			color: #196297;
		}

		a:hover {
			color: #FE4819;
		}
    </style>
</head>
<body>
    <div class="Header">
        <h1>System Compatibility Check Script</h1>
    </div>
    <br class="Clear">
    <div class="Content">
        <h2>Basic Information</h2>
        <ul>
            <?php
            echo '<li>PHP is running in ' . CHECK_PHP_SAPI . ' mode</li>';
            if (!CHECK_CGI_MODE && CHECK_MOD_SECURITY_ENABLED) {
                echo "<li>mod_security is running - tinyMCE may break with this on</li>\n";
            }
            ?>
        </ul>
        <?php
        $products = [
            'Required_Functions',
            'Sessions',
            [
                'label' => 'Email_Marketer',
                'url' => 'https://www.interspire.com/'
            ],
        ];

        foreach ($products as $product_details) {
            if (!is_array($product_details)) {
                $product = $product_details;
                $url = '';
            } else {
                $product = $product_details['label'];
                $url = $product_details['url'];
            }

            $check_func = 'Check_' . $product;

            echo empty($url) 
                ? '<h2>' . str_replace('_', ' ', $product) . '</h2>'
                : '<h2><a href="' . $url . '">' . str_replace('_', ' ', $product) . '</a></h2>';
            
            echo '<div><ul>';
            if (function_exists($check_func)) {
                $check_func();
            }
            echo '</ul></div>';
        }
        ?>
    </div>
</body>
</html>

<?php

function parsePHPModules(): array
{
    ob_start();
    phpinfo(INFO_MODULES);
    $s = ob_get_clean();

    $s = strip_tags($s, '<h2><th><td>');
    $s = preg_replace('/<th[^>]*>([^<]+)<\/th>/', "<info>\\1</info>", $s);
    $s = preg_replace('/<td[^>]*>([^<]+)<\/td>/', "<info>\\1</info>", $s);
    $vTmp = preg_split('/(<h2[^>]*>[^<]+<\/h2>)/', $s, -1, PREG_SPLIT_DELIM_CAPTURE);
    $vModules = [];
    
    for ($i = 1; $i < count($vTmp); $i++) {
        if (preg_match('/<h2[^>]*>([^<]+)<\/h2>/', $vTmp[$i], $vMat)) {
            $vName = trim($vMat[1]);
            $vTmp2 = explode("\n", $vTmp[$i + 1]);
            foreach ($vTmp2 as $vOne) {
                $vPat = '<info>([^<]+)<\/info>';
                $vPat3 = "/$vPat\s*$vPat\s*$vPat/";
                $vPat2 = "/$vPat\s*$vPat/";
                if (preg_match($vPat3, $vOne, $vMat)) {
                    $vModules[$vName][trim($vMat[1])] = [trim($vMat[2]), trim($vMat[3])];
                } elseif (preg_match($vPat2, $vOne, $vMat)) {
                    $vModules[$vName][trim($vMat[1])] = trim($vMat[2]);
                }
            }
        }
    }
    return $vModules;
}

function parseApacheModules(): array
{
    $input = parsePHPModules();
    if (isset($input['apache'])) {
        $modules = $input['apache']['Loaded Modules'];
        return array_map('trim', explode(',', $modules));
    } elseif (isset($input['apache2handler'])) {
        $modules = $input['apache2handler']['Loaded Modules'];
        return array_map('trim', explode(' ', $modules));
    }
    return [];
}

function DisplayResults(array $checks, string $section = ''): void
{
    if (empty($checks)) {
        return;
    }

    echo '<fieldset>' . "\n";
    if (!empty($section)) {
        echo '<legend>' . $section . '</legend>' . "\n";
    }
    echo "<dl>\n";

    foreach ($checks as $label => $check) {
        echo "<dt>" . htmlspecialchars($label) . ":</dt>\n";

        if (is_array($check)) {
            if ($check['result'] === true) {
                echo '<dd class="CheckResult Pass">Ok</dd>' . "\n";
                if (isset($check['version'])) {
                    echo '<dd class="CheckResultFeature">Version <em>' . htmlspecialchars($check['version']) . '</em></dd>' . "\n";
                }
                if (isset($check['refresh'])) {
                    echo '<dd class="CheckResultFeature"><em><a href="check_iem.php">Retest</a></em></dd>' . "\n";
                    if (CHECK_SESSION_OK !== true) {
                        echo '<dd class="CheckResultFeature">Current session variables:</dd>' . "\n";
                        echo '<dd class="CheckResultFeature"><em>' . htmlspecialchars(print_r($_SESSION, true)) . '</em></dd>' . "\n";
                    }
                }
            } elseif ($check['result'] === false) {
                echo '<dd class="CheckResult Fail">Not Ok</dd>' . "\n";
                if (isset($check['refresh'])) {
                    echo '<dd class="CheckResultFeature"><em><a href="check_iem.php">Retest</a></em></dd>' . "\n";
                } else {
                    echo '<dd class="CheckResultFeature">This feature is required for: <em>' . htmlspecialchars($check['feature']) . '</em></dd>' . "\n";
                    echo '<dd class="CheckResultFix">To fix this: <em>' . htmlspecialchars($check['fix']) . '</em></dd>' . "\n";
                }
            } else {
                echo '<dd class="CheckResult Unknown">Unknown</dd>' . "\n";
                echo '<dd class="CheckResultFeature">This feature is required for: <em>' . htmlspecialchars($check['feature']) . '</em></dd>' . "\n";
                echo '<dd class="CheckResultFix">To fix this: <em>' . htmlspecialchars($check['fix']) . '</em></dd>' . "\n";
            }
        } else {
            echo '<dd class="CheckResult ' . ($check === true ? 'Pass">Ok' : ($check === false ? 'Fail">Not Ok' : 'Unknown">Unknown')) . '</dd>' . "\n";
        }
    }

    echo '</dl>' . "\n";
    echo '</fieldset>' . "\n";
    echo '<br class="Clear" />' . "\n";
}



function Check_Sessions(): void
{
    $checks = [
        'Sessions working ok' => [
            'result' => CHECK_SESSION_OK,
            'refresh' => 1
        ],
        'Session autostart disabled' => !CHECK_SESSION_AUTOSTART,
        'Session referer check correct' => CHECK_SESSION_REFERER_CHECK_CORRECT,
    ];
    DisplayResults($checks);
}

function Check_Required_Functions(): void
{
    $required_functions = [
        'fopen',
        'fread',
        'fwrite', // Changed from fputs to fwrite (preferred in modern PHP)
        'opendir',
        'readdir',
        'closedir',
        'mail',
        'parse_ini_file',
        'ini_set',
    ];

    $checks = [];
    foreach ($required_functions as $func) {
        $checks[$func . '()'] = function_exists($func);
    }

    DisplayResults($checks);
}

function Check_Email_Marketer(): void
{
    $init_file = './../com/init.php';
    if (is_readable($init_file)) {
        define('IEM_NO_CONTROLLER', true);
        require_once $init_file;
    }

    $required = [];

    // Require PHP 8.1 to 8.3
    $current_version = phpversion();
    $required['PHP 8.1 to 8.3'] = [
        'result' => version_compare($current_version, '8.1.0', '>=') && version_compare($current_version, '8.4.0', '<'),
        'feature' => 'Application',
        'fix' => 'Your current PHP version is ' . $current_version . '. Please ask your host to upgrade/configure your server to PHP version 8.1-8.3',
        'version' => $current_version
    ];

    // Remove ZendEngine1 check as it's no longer relevant
	// Remove safe mode check as it's no longer relevant

    $required['File Uploads'] = CHECK_FILE_UPLOADS;

    // MySQLi checks
    $required['MySQLi Available'] = [
        'result' => CHECK_MYSQLi_AVAILABLE,
        'version' => MYSQLi_VERSION_CHECK
    ];

    // Check if MySQLi version is adequate
    if (CHECK_MYSQLi_AVAILABLE && !empty(MYSQLi_VERSION_CHECK)) {
        // Extract version number from mysqlnd string if present
        if (preg_match('/mysqlnd ([0-9]+\.[0-9]+\.[0-9]+)/', MYSQLi_VERSION_CHECK, $matches)) {
            $version = $matches[1];
        } else {
            $version = MYSQLi_VERSION_CHECK;
        }
        
        $required['MySQLi version 5.0 or above'] = [
            'result' => version_compare($version, '5.0.0', '>='),
            'feature' => 'Database functionality',
            'fix' => 'Please upgrade MySQL to version 5.0 or above',
            'version' => MYSQLi_VERSION_CHECK
        ];
    }

    // Modern PHP Extension Checks
    $required['mbstring Extension'] = [
        'result' => CHECK_MBSTRING_AVAILABLE,
        'feature' => 'Unicode string handling',
        'fix' => 'Please ask your web host to install the PHP mbstring extension'
    ];

    $required['DOM Extension'] = [
        'result' => CHECK_DOM_AVAILABLE,
        'feature' => 'XML processing and surveys',
        'fix' => 'Please ask your web host to install the PHP DOM extension'
    ];

    $required['cURL Extension'] = [
        'result' => CHECK_CURL_AVAILABLE,
        'feature' => 'Remote API connections',
        'fix' => 'Please ask your web host to install the PHP cURL extension'
    ];

    // Session configuration check
    $required['Session Autostart Disabled'] = [
        'result' => !CHECK_SESSION_AUTOSTART,
        'feature' => 'Session management',
        'fix' => 'Please disable session.auto_start in php.ini'
    ];

    // IMAP checks
    $required['IMAP Extension'] = [
        'result' => CHECK_IMAP_AVAILABLE,
        'feature' => 'Bounce processing',
        'fix' => 'Please ask your web host to install the PHP IMAP extension'
    ];

    // Remote URL access check
    $required['Remote URL Access'] = [
        'result' => ACCESS_REMOTE_URL,
        'feature' => 'External API connections and updates',
        'fix' => 'Please ensure either cURL is installed or allow_url_fopen is enabled'
    ];

    // GD Library check
    $required['GD Extension'] = [
        'result' => CHECK_GD_AVAILABLE,
        'feature' => 'Image processing and CAPTCHA',
        'fix' => 'Please ask your web host to install the PHP GD extension'
    ];

    // ModSecurity check
    if (!is_null(CHECK_MOD_SECURITY_ENABLED)) {
        $required['ModSecurity Status'] = [
            'result' => !CHECK_MOD_SECURITY_ENABLED,
            'feature' => 'TinyMCE and form submissions',
            'fix' => 'Consider disabling mod_security or configuring it properly for the application'
        ];
    }

    // JSON Extension check (required for modern web applications)
    $required['JSON Extension'] = [
        'result' => CHECK_JSON_AVAILABLE,
        'feature' => 'API functionality and data processing',
        'fix' => 'Please ask your web host to install the PHP JSON extension'
    ];

    // Optional features
    $optional = [
        'fsockopen() Available' => [
            'result' => CHECK_FSOCKOPEN_AVAILABLE,
            'feature' => 'Remote SMTP connections',
            'fix' => 'Enable fsockopen() function for SMTP support'
        ],
        'Zlib Extension' => [
            'result' => CHECK_ZLIB_AVAILABLE,
            'feature' => 'Data compression',
            'fix' => 'Install PHP Zlib extension for better performance'
        ],
        'SimpleXML Extension' => [
            'result' => CHECK_SIMPLEXML_AVAILABLE,
            'feature' => 'XML processing',
            'fix' => 'Install PHP SimpleXML extension for enhanced XML support'
        ]
    ];

    // Display results
    DisplayResults($required, 'Required Components');
    DisplayResults($optional, 'Optional Components');
}